const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class PoliciesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const policies = await db.policies.create(
      {
        id: data.id || undefined,

        scope: data.scope || null,
        rule_logic: data.rule_logic || null,
        effect: data.effect || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await policies.setOrganizations(data.organizations || null, {
      transaction,
    });

    return policies;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const policiesData = data.map((item, index) => ({
      id: item.id || undefined,

      scope: item.scope || null,
      rule_logic: item.rule_logic || null,
      effect: item.effect || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const policies = await db.policies.bulkCreate(policiesData, {
      transaction,
    });

    // For each item created, replace relation files

    return policies;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const policies = await db.policies.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.scope !== undefined) updatePayload.scope = data.scope;

    if (data.rule_logic !== undefined)
      updatePayload.rule_logic = data.rule_logic;

    if (data.effect !== undefined) updatePayload.effect = data.effect;

    updatePayload.updatedById = currentUser.id;

    await policies.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await policies.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return policies;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const policies = await db.policies.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of policies) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of policies) {
        await record.destroy({ transaction });
      }
    });

    return policies;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const policies = await db.policies.findByPk(id, options);

    await policies.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await policies.destroy({
      transaction,
    });

    return policies;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const policies = await db.policies.findOne({ where }, { transaction });

    if (!policies) {
      return policies;
    }

    const output = policies.get({ plain: true });

    output.organizations = await policies.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.scope) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('policies', 'scope', filter.scope),
        };
      }

      if (filter.rule_logic) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('policies', 'rule_logic', filter.rule_logic),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.effect) {
        where = {
          ...where,
          effect: filter.effect,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.policies.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('policies', 'scope', query),
        ],
      };
    }

    const records = await db.policies.findAll({
      attributes: ['id', 'scope'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['scope', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.scope,
    }));
  }
};
